% Skript file: project_startup.m
%
% Purpose: Setup to use Development Framework
%
% Record of revision
%   Date        Engineer    Description of change
%   ====        ========    =====================
% 31.05.16      R.Peterer   my_startup to add all necessary paths
% 06.06.16      C.Schmid    changed path for Lianx Reference Design
% 22.06.16      R.Peterer   changed output of "add custom reference design
% to Matlab path" did not evaluate the board name(s)
% 22.06.16      C.Schmid    uncommented zynq initalisation
% 24.06.16      C.Schmid    merged with my_startup

%% add Simulink Library to Matlab path
currentpath = pwd;
fprintf('current path: %s\n',currentpath);
parentpath = cd(cd('..\..'));
fprintf('parrent path: %s\n',parentpath);
addpath(fullfile(parentpath,'05_sim_library'));
mylib = slblocks;
fprintf('Added Simulink Library: %s\n',mylib.Browser.Name);

%% add custom reference design to Matlab path
path = fullfile(parentpath,'02_custom_ref_design');
addpath(fullfile(path,'LianxZedBoards'));
try
    boards = eval('hdlcoder_board_customization');
    for n = 1:numel(boards)
        board = eval(boards{1,n});
        fprintf('Added Board(s): %s\n', board.BoardName);
    end
catch
    fprintf('No Custom Ref Design available\n');
end

%% 1: Zynq specific startup items
hdlsetuptoolpath('ToolName', 'Xilinx Vivado', ...
    'ToolPath', 'C:\Xilinx\Vivado\2014.4\bin\vivado.bat');

%% 2: Set up the Zynq hardware connection
%(Once per MATLAB session)
z = zynq('linux','192.168.2.101','root','root','/tmp');
z.setupZynqHardware();

%% 3: Test connection
fprintf('%s',z.checkConnection());

%% 4: change to framework work directory
cd('..\work');