function varargout = RemoteSystemInteraction(varargin)
%REMOTESYSTEMINTERACTION M-file for RemoteSystemInteraction.fig
%      REMOTESYSTEMINTERACTION, by itself, creates a new REMOTESYSTEMINTERACTION or raises the existing
%      singleton*.
%
%      H = REMOTESYSTEMINTERACTION returns the handle to a new REMOTESYSTEMINTERACTION or the handle to
%      the existing singleton*.
%
%      REMOTESYSTEMINTERACTION('Property','Value',...) creates a new REMOTESYSTEMINTERACTION using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to RemoteSystemInteraction_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      REMOTESYSTEMINTERACTION('CALLBACK') and REMOTESYSTEMINTERACTION('CALLBACK',hObject,...) call the
%      local function named CALLBACK in REMOTESYSTEMINTERACTION.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help RemoteSystemInteraction

% Last Modified by GUIDE v2.5 23-Jun-2016 08:35:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @RemoteSystemInteraction_OpeningFcn, ...
                   'gui_OutputFcn',  @RemoteSystemInteraction_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% TODO: Enter close function when shuting down gui, to proper release udp
% obj

%% GUI Part itself
% --- Executes just before RemoteSystemInteraction is made visible.
function RemoteSystemInteraction_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for RemoteSystemInteraction
handles.output = hObject;

% invisible elements at opening
listInvisible = {handles.uipanel2, handles.uipanel3, handles.uipanel4,...
    handles.uipanel5, handles.uipanel6,...
    handles.uipanel7, handles.uipanel8};

for idx = 1:numel(listInvisible)
    set(listInvisible{idx},'Visible','off');
end
listDisable = {handles.TargetIPAddress};
for idx = 1:numel(listDisable)
    set(listDisable{idx},'Enable','off');
end

% reset old instrument object (udp)
instrreset;

% Setup GUI Storage
handles.GUI_Storage = findall(0,'Name','RemoteSystemInteraction');

% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = RemoteSystemInteraction_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%% Global Settings
% --- Executes on button press in APIReadData.
function APIReadData_Callback(hObject, eventdata, handles)
% hObject    handle to APIReadData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% load API
[filename, path, ~] = uigetfile('../*.mat');
APIData = load(fullfile(path, filename));
handles.API = APIData.API;

% initialise GUI
handles = init_gui(handles);
% enable IP Address
handles.TargetIPAddress.Enable = 'on';
% Update handles structure
guidata(hObject, handles);

function TargetIPAddress_Callback(hObject, eventdata, handles)
% hObject    handle to TargetIPAddress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% TODO add validity check for new IP Address

% --- Executes during object creation, after setting all properties.
function TargetIPAddress_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TargetIPAddress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Continuous Signal
% --- Executes on button press in ContSigDisconnect.
function ContSigDisconnect_Callback(hObject, ~, handles)
% hObject    handle to ContSigDisconnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles, state] = udp_ContSig(handles, 0);
if state > 0
    error('Something went wrong to delete UDP Connection SetGet');
end
guidata(hObject, handles);

% --- Executes on button press in ContSigConnect.
function ContSigConnect_Callback(hObject, eventdata, handles)
% hObject    handle to ContSigConnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles, state] = udp_ContSig(handles, 1);
if state == 1
    set(hObject,'Value',1.0);
elseif state == 0
    error('Could not establish UDP Connection to SetGet');
else
    error('Something went wrong!');
end
guidata(hObject, handles);

function xAxisTime_Callback(hObject, eventdata, handles)
% hObject    handle to xAxisTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
value = str2double(handles.xAxisTime.String);
if isnan(value)
    value = 10;
    hObject.xAxisTime.String = num2str(value);
    msgbox('Value is not a Number!')
end
if value < 1
    value = 1;
    hObject.xAxisTime.String = num2str(value);
    msgbox('Value is out of range!');
end
handles.xAxisTimeVal = value;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function xAxisTime_CreateFcn(hObject, eventdata, handles)
% hObject    handle to xAxisTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Contect Menu
function ContinuousSignal1AxesProp_Callback(hObject, eventdata, handles)
% hObject    handle to ContinuousSignal1AxesProp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Contect Menu
function Signal1YAxesLimits_Callback(hObject, eventdata, handles)
% hObject    handle to Signal1YAxesLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
prompt = {'Enter y min:','Enter y max'};
dlg_title = 'Continuous Signal Y Axis Setting';
num_lines = 1;
defaultans = cellstr(num2str(handles.ContinuousSignal1.YLim(:)))';
%defaultans = {'1','-1'};
yLim = str2double(inputdlg(prompt,dlg_title,num_lines,defaultans));
if numel(yLim)>1
    if isnan(yLim(1)) || isnan(yLim(2))
        yLim(1) = str2double(defaultans{1});
        yLim(2) = str2double(defaultans{2});
        msgbox('Entered Value is not a Number!');
    end
else
    yLim(1) = str2double(defaultans{1});
    yLim(2) = str2double(defaultans{2});
end
set(handles.ContinuousSignal1,'YLim',yLim,'YTick',linspace(yLim(1),yLim(2),5)) 

% Contect Menu
function ContinuousSignal2AxesProp_Callback(hObject, eventdata, handles)
% hObject    handle to ContinuousSignal2AxesProp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Contect Menu
function Signal2YAxesLimits_Callback(hObject, eventdata, handles)
% hObject    handle to Signal2YAxesLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
prompt = {'Enter YLim min:','Enter YLim max'};
dlg_title = 'Continuous Signal Y Axis Setting';
num_lines = 1;
defaultans = cellstr(num2str(handles.ContinuousSignal2.YLim(:)))';
%defaultans = {'1','-1'};
yLim = str2double(inputdlg(prompt,dlg_title,num_lines,defaultans));
if numel(yLim)>1
    if isnan(yLim(1)) || isnan(yLim(2))
        yLim(1) = str2double(defaultans{1});
        yLim(2) = str2double(defaultans{2});
        msgbox('Entered Value is not a Number!');
    end
else
    yLim(1) = str2double(defaultans{1});
    yLim(2) = str2double(defaultans{2});
end
set(handles.ContinuousSignal2,'YLim',yLim,'YTick',linspace(yLim(1),yLim(2),5)) 

%% Control Target
% --- Executes on button press in CtrlTargetOn.
function CtrlTargetOn_Callback(hObject, eventdata, handles)
% hObject    handle to CtrlTargetOn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% ControlTarget udp obj
[handles, state] = udp_CtrlTarget(handles, 1);
if state == 1
   set(handles.run,'Enable','on');
   set(handles.stop,'Enable','on');
   set(handles.reset,'Enable','on');
   set(handles.currentState,'Visible','on');
   set(handles.MonitoringIsTripped,'Visible','on');
else 
    set(handles.run,'Enable','off');
    set(handles.stop, 'Enable','off');
    set(handles.reset,'Enable','off');
    set(handles.currentState,'Visible','off');
    set(handles.MonitoringIsTripped,'Visible','off');
    set(hObject,'Value',0);
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in CtrlTargetOff.
function CtrlTargetOff_Callback(hObject, eventdata, handles)
% hObject    handle to CtrlTargetOff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles, state] = udp_CtrlTarget(handles, 0);
if state < 1
    set(handles.run,'Enable','off');
    set(handles.stop, 'Enable','off');
    set(handles.reset,'Enable','off');
    set(handles.currentState,'Visible','off');
    set(handles.MonitoringIsTripped,'Visible','off');
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in run.
function run_Callback(hObject, eventdata, handles)
% hObject    handle to run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = uint8(2);
try
    fwrite(handles.udp.CtrlTarget, data, 'uint8');
catch
    %todo: just for debbuging
    disp('Could not send Run command.');
end

% --- Executes on button press in stop.
function stop_Callback(hObject, eventdata, handles)
% hObject    handle to stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = uint8(1);
try
    fwrite(handles.udp.CtrlTarget, data, 'uint8');
catch
    %todo: just for debbuging
    disp('Could not send Stop command.');
end

% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = uint8(0);
try
    fwrite(handles.udp.CtrlTarget, data, 'uint8');
catch
    %todo: just for debbuging
    disp('Could not send Reset command.');
end

%% Set Get Parameters
% --- Executes on button press in SetGetDisconnect.
function SetGetDisconnect_Callback(hObject, eventdata, handles)
% hObject    handle to SetGetDisconnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isfield(handles.API, 'SetParam') && isfield(handles.API, 'GetParam')
    [handles, state1] = udp_SetParam(handles, 0);
    [handles, state2] = udp_GetParam(handles, 0);
    if sum([state1, state2]) > 0
        error('Could not delete UDP object GetParam SetParam');
    end
elseif isfield(handles.API, 'SetParam') && ~isfield(handles.API, 'GetParam')
    [handles, state1] = udp_SetParam(handles, 0);
    if state1 > 0
        error('Could not delete UDP object GetParam SetParam');
    end
elseif ~isfield(handles.API, 'SetParam') && isfield(handles.API, 'GetParam')
    [handles, state2] = udp_GetParam(handles, 0);
    if state2 > 0
        error('Could not delete UDP object GetParam SetParam');
    end
end
set(handles.setParameters,'Enable','off');
set(hObject, 'Value',1.0);
guidata(hObject, handles);

% --- Executes on button press in SetGetConnect.
function SetGetConnect_Callback(hObject, eventdata, handles)
% hObject    handle to SetGetConnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isfield(handles.API, 'SetParam') && isfield(handles.API, 'GetParam')
    [handles, state1] = udp_SetParam(handles, 1);
    [handles, state2] = udp_GetParam(handles, 1);
    if sum([state1,state2]) == 2
        set(hObject, 'Value',1.0);
        handles.setParameters.Enable = 'on';
    else
        if state1 < 1
            handles.setParameters.Enable = 'off';
            error('Could not create UDP Object SetParam');
        end
        if state2 < 1
            error('Could not create UDP Object GetParam');
        end    
    end   
elseif isfield(handles.API, 'SetParam') && ~isfield(handles.API, 'GetParam');
    [handles, state1] = udp_SetParam(handles, 1);
    if state1 == 1
        set(hObject, 'Value', 1.0);
        handles.setParameters.Enable = 'on';
    else
        handles.setParameters.Enable = 'off';
        error('Could not create UDP Object SetParam')
    end   
elseif ~isfield(handles.API, 'SetParam') && isfield(handles.API, 'GetParam')
    [handles, state2] = udp_GetParam(handles, 1);
    if state2 == 1
        set(hObject, 'Value', 1.0);
    else
        error('Could not create UDP Object GetParam');
    end
end
guidata(hObject, handles);

% --- Executes on button press in setParameters.
function setParameters_Callback(hObject, eventdata, handles)
% hObject    handle to setParameters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% TODO: implement check with status table values okay

data = get(handles.SetParametersTable,'Data');


uint32data = Setdata2uint32(data);
try
    fwrite(handles.udp.Set, uint32data, 'uint32');
catch
    disp('Could not write new SetValues!');
end

% --- Executes when entered data in editable cell(s) in SetParametersTable.
function SetParametersTable_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to SetParametersTable (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
newValue = eventdata.NewData;
oldValue = eventdata.PreviousData;
r = eventdata.Indices(1);
c = eventdata.Indices(2);
minVal = hObject.Data{r,4};
maxVal = hObject.Data{r,5};
datatype = hObject.Data{r,6};

% test validity of value before set (datatype and range)
if newValue <= maxVal && newValue >= minVal
    try 
        datatype = numerictype(datatype);   % create numerictype object
        datatype.WordLength = 32;           % expand wordlength to 32
        value = fi(newValue,datatype,'RoundingMethod','Floor');
        hObject.Data{r,c} = str2double(value.Value);
        
    catch
        warning('Datatype %s not yet defined',datatype);
        
    end
else 
    hObject.Data{r,c} = oldValue;
    handles.edit = msgbox(sprintf('New Value out of Range!\nRange: %s to %s',num2str(minVal), num2str(maxVal)),'Error','error');
end

%% Trigger Control
% --- Executes on button press in TriggerConnect.
function TriggerConnect_Callback(hObject, eventdata, handles)
% hObject    handle to TriggerConnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.SignalTrigger.Enable = 'off';
[handles, state] = udp_TriggerSetValues(handles, 1);
handles.PreloadNewSetValue.Enable = 'on';
set(handles.FIFOReadOutOn,'Value',1);
handles.TriggerOn = 1;
if state == 1
    set(hObject,'Value',1.0);
elseif state == 0
    error('Could not establish UDP Connection to TriggerSetValues');
else
    error('Something went wrong!');
end
guidata(hObject, handles);

% --- Executes on button press in TriggerDisconnect.
function TriggerDisconnect_Callback(hObject, eventdata, handles)
% hObject    handle to TriggerDisconnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.SignalTrigger.Enable = 'off';
[handles, state] = udp_TriggerSetValues(handles, 0);
handles.PreloadNewSetValue.Enable = 'off';
[handles, state2] = udp_Trigger(handles, 0);
if state2 == 0
    delete(handles.udp.PLFIFOGet);
end
if state > 0 || state2 > 0
    error('Something went wrong to delete UDP Connection Trigger or Trigger Set Values.');
end

guidata(hObject, handles);

function FIFOSampleShift_Callback(hObject, eventdata, handles)
% hObject    handle to FIFOSampleShift (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.SignalTrigger.Enable = 'off';
value = str2double(hObject.String);
if isnan(value)
    msgbox('Value is not a Number!')
    value = 0;
else
    if value > handles.API.PLFIFOBuf.PLFIFOSize
        msgbox('Value is bigger than PL FIFO Buffer Size!')
        value = handles.API.PLFIFOBuf.PLFIFOSize;
    else
        value = nearest(value);
    end
end
hObject.String = num2str(value);
handles.User_SampleShift.String = sprintf('%i',value);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function FIFOSampleShift_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FIFOSampleShift (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function FIFOPushSampleTime_Callback(hObject, eventdata, handles)
% hObject    handle to FIFOPushSampleTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.SignalTrigger.Enable = 'off';
value = str2double(hObject.String);
if isnan(value)
    msgbox('Value is not a Number!')
    value = 0;
else
    if value > 1e8
        msgbox('Value is out of range!')
        value = 1e8;
    elseif value < 1
        msgbox('Value is out of range!');
        value = 1;
    else
        value = nearest(value);
    end
end
hObject.String = num2str(value);
handles.User_PushSampleTime.String = sprintf('%e s',value*10e-9);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function FIFOPushSampleTime_CreateFcn(hObject, ~, handles)
% hObject    handle to FIFOPushSampleTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes when entered data in editable cell(s) in TriggerValuesTable.
function TriggerValuesTable_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to TriggerValuesTable (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
handles.SignalTrigger.Enable = 'off';
newValue = eventdata.NewData;
oldValue = eventdata.PreviousData;
r = eventdata.Indices(1);
c = eventdata.Indices(2);
minVal = hObject.Data{r,4};
maxVal = hObject.Data{r,5};
datatype = hObject.Data{r,6};

% test validity of value before set (datatype and range)
if newValue <= maxVal && newValue >= minVal
    try 
        datatype = numerictype(datatype);   % create numerictype object
        datatype.WordLength = 32;           % expand wordlength to 32
        value = fi(newValue,datatype,'RoundingMethod','Floor');
        hObject.Data{r,c} = str2double(value.Value);
        
    catch
        warning('Datatype %s not yet defined',datatype);
        
    end
else 
    hObject.Data{r,c} = oldValue;
    handles.edit = msgbox(sprintf('New Value out of Range!\nRange: %s to %s',num2str(minVal), num2str(maxVal)),'Error','error');
end

% --- Executes on button press in PreloadNewSetValue.
function PreloadNewSetValue_Callback(hObject, eventdata, handles)
% hObject    handle to PreloadNewSetValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = get(handles.TriggerValuesTable,'Data');
ConvertedData = Setdata2uint32(data);
SetValue1 = ConvertedData(1);
SetValue2 = ConvertedData(2);
% control signals
enFIFO = uint32(handles.TriggerOn);
PushSampleTime = uint32(str2double(handles.FIFOPushSampleTime.String));
SampleShift = uint32(str2double(handles.FIFOSampleShift.String));
Trigger = uint32(handles.CurrentTriggerValue.Value);
% prepare send vector [enFIFO, PushSampleTime, SampleShift, Trigger, SetValue1, SetValue2]
SendVector = [enFIFO, PushSampleTime, SampleShift, Trigger, SetValue1, SetValue2];
try
    fwrite(handles.udp.PLFIFOBuf, SendVector, 'uint32');
    handles.lastSendVector = SendVector;
    if enFIFO == 1
        handles.SignalTrigger.Enable = 'on';
    end
catch
    disp('could not write new data');
end
guidata(hObject, handles);

% --- Executes on button press in SignalTrigger.
function SignalTrigger_Callback(hObject, eventdata, handles)
% hObject    handle to SignalTrigger (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isfield(handles, 'lastSendVector')
    %lastSendVector = handles.lastSendVector;
    [handles, state] = udp_Trigger(handles, 1);
    handles.SignalTrigger.Enable = 'off';
    if state == 1
        set(hObject,'Value',1.0);
    elseif state == 0
        error('Could not establish UDP Connection to TriggerSetValues');
    else
        error('Something went wrong!');
    end
else
    error('Something went wrong');
end
guidata(hObject, handles);

% --- Executes on button press in FIFOReadOutOn.
function FIFOReadOutOn_Callback(hObject, eventdata, handles)
% hObject    handle to FIFOReadOutOn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.SignalTrigger.Enable = 'off';
hObject.Value = 1;
handles.TriggerOn = 1;
guidata(hObject, handles)

% --- Executes on button press in FIFOReadOutOff.
function FIFOReadOutOff_Callback(hObject, eventdata, handles)
% hObject    handle to FIFOReadOutOff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.SignalTrigger.Enable = 'off';
hObject.Value = 1;
handles.TriggerOn = 0;
guidata(hObject, handles)

% Context Menu
function TriggerData1AxesProp_Callback(hObject, eventdata, handles)
% hObject    handle to TriggerData1AxesProp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Context Menu
function Trigger1YAxesLimits_Callback(hObject, eventdata, handles)
% hObject    handle to Trigger1YAxesLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
prompt = {'Enter YLim min:','Enter YLim max'};
dlg_title = 'Trigger Signal Y Axis Setting';
num_lines = 1;
defaultans = cellstr(num2str(handles.TriggerData1.YLim(:)))';
yLim = str2double(inputdlg(prompt,dlg_title,num_lines,defaultans));
if numel(yLim)>1
    if isnan(yLim(1)) || isnan(yLim(2))
        yLim(1) = str2double(defaultans{1});
        yLim(2) = str2double(defaultans{2});
        msgbox('Entered Value is not a Number!');
    end
else
    yLim(1) = str2double(defaultans{1});
    yLim(2) = str2double(defaultans{2});
end
set(handles.TriggerData1,'YLim',yLim,'YTick',linspace(yLim(1),yLim(2),5));

% Context Menu
function TriggerData2AxesProp_Callback(hObject, eventdata, handles)
% hObject    handle to TriggerData2AxesProp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Context Menu

function Trigger2YAxesLimits_Callback(hObject, eventdata, handles)
% hObject    handle to Trigger2YAxesLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
prompt = {'Enter YLim min:','Enter YLim max'};
dlg_title = 'Trigger Signal Y Axis Setting';
num_lines = 1;
defaultans = cellstr(num2str(handles.TriggerData2.YLim(:)))';
yLim = str2double(inputdlg(prompt,dlg_title,num_lines,defaultans));
if numel(yLim)>1
    if isnan(yLim(1)) || isnan(yLim(2))
        yLim(1) = str2double(defaultans{1});
        yLim(2) = str2double(defaultans{2});
        msgbox('Entered Value is not a Number!');
    end
else
    yLim(1) = str2double(defaultans{1});
    yLim(2) = str2double(defaultans{2});
end
set(handles.TriggerData2,'YLim',yLim,'YTick',linspace(yLim(1),yLim(2),5)); 


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
