function [ handles ] = init_gui(input)
%init_gui Summary of this function goes here
%   Detailed explanation goes here
handles = input;
API = handles.API;

try
    % Model Name
    if isfield(API,'modelName')
        set(handles.ModelName, 'String',API.modelName);
    else
        set(handles.ModelName, 'String','No Model Name found!');
        error('No Model Name found!');
    end
    % Parent Set Get Panel
    if isfield(API,'SetParam') || isfield(API,'GetParam')
        set(handles.uipanel3,'Visible','on');
        % Set Parameter Panel
        if isfield(API,'SetParam')
            set(handles.setParameters,'Enable','off');
            set(handles.uipanel4,'Visible','on');
            nrSetParam = numel(API.SetParam.ParamName);
            % create table data cell
            % check if Min Max has empty cells and fill with 0;
            API.SetParam.Min(cellfun(@isempty,API.SetParam.Min)) = {0};
            API.SetParam.Max(cellfun(@isempty,API.SetParam.Max)) = {0};
            %idx = cellfun(@isempty,NewSetValue);
           % NewSetValue(idx) = {0};
            d = [API.SetParam.ParamName, num2cell(zeros(nrSetParam,1)), ...
                API.SetParam.Min,...% Initial Set Values num2cell(zeros(nrSetParam,1)),...
                API.SetParam.Min,...
                API.SetParam.Max, API.SetParam.DataType];
            set(handles.SetParametersTable,'Data',d);
        else
            set(handles.uipanel4,'Visible','off');
            msgbox('No Set Parameter available!');
        end
        % Get Parameter Panel
        if isfield(API,'GetParam')
            set(handles.uipanel5,'Visible','on');
            nrGetParam = numel(API.GetParam.ParamName);
            % create table data cell
            d = [API.GetParam.ParamName, num2cell(zeros(nrGetParam,1)), ...
                API.GetParam.DataType];
            set(handles.GetParametersTable,'Data',d);
        else
            set(handles.uipanel5,'Visible','off');
            msgbox('No Get Parameter available!')
        end
    else
        set(handles.uipanel3,'Visible','off');
        msgbox('No Set nor Get Parameter available!');
    end
    % Control Target
    if isfield(API,'CtrlTarget')
        set(handles.uipanel2, 'Visible', 'on');
        % prepare control buttons
        set(handles.run,'Enable','off');
        set(handles.stop, 'Enable','off');
        set(handles.reset,'Enable','off');
        set(handles.currentState,'Visible','off');
        set(handles.MonitoringIsTripped,'Visible','off');
        set(handles.CtrlTargetOn,'Value',0);
    else
        set(handles.uipanel2, 'Visible', 'off');
        msgbox('No Control Target Block available!');
    end
    % Continuous Signal
    if isfield(API,'ContSig')
        set(handles.uipanel7, 'Visible', 'on');
        set(handles.ContSigConnect,'Value',0);
    else
        set(handles.uipanel7, 'Visible', 'off');
        msgbox('No Continuous Signal Block available!');
    end
    
    % Trigger Signal
    if isfield(API,'PLFIFOBuf')
        set(handles.uipanel6, 'Visible', 'on');
        set(handles.uipanel8, 'Visible', 'on');
        % prepare control buttons
        set(handles.PreloadNewSetValue, 'Enable', 'off');
        set(handles.SignalTrigger, 'Enable', 'off');
        % setup value table
        nrSetParam = numel(API.PLFIFOBuf.SetParamName);
        % create table data cell
        % check if Min Max has empty cells and fill with 0;
        API.PLFIFOBuf.Min(cellfun(@isempty,API.SetParam.Min)) = {0};
        API.PLFIFOBuf.Max(cellfun(@isempty,API.SetParam.Max)) = {0};
        d = [API.PLFIFOBuf.SetParamName, num2cell(zeros(nrSetParam,1)), ...
            API.PLFIFOBuf.Min ,API.PLFIFOBuf.Min,...
            API.PLFIFOBuf.Max, API.PLFIFOBuf.OutportDataType(1:nrSetParam)];
        set(handles.TriggerValuesTable,'Data',d);
    else
        set(handles.uipanel6, 'Visible', 'off');
        set(handles.uipanel8, 'Visible', 'off');
        msgbox('No PL FIFO Block available!');
    end
    
    % IP Address
    
%     % Enable connection to target
      % TODO: implement check connection to target
    
catch
    msgbox('Could not load Model API!','Error','error');
end

end

