function [ handles, state ] = udp_CtrlTarget( input, on_off )
%UDP_CTRLTARGET Summary of this function goes here
%   Detailed explanation goes here
handles = input;

try
    if on_off == 1   % setup udp object
        IPAddress = get(handles.TargetIPAddress,'String');
        remotePort = handles.API.CtrlTarget.LocalPort;
        localPort = handles.API.CtrlTarget.RemotePort;

        % create udp object
        handles.udp.CtrlTarget = udp(IPAddress, remotePort, 'LocalPort',localPort);
        handles.udp.CtrlTarget.Name = 'udp_CtrlTarget';
        handles.udp.CtrlTarget.ByteOrder = 'littleEndian';
        
        % todo: BytesAvailableFcnCount needs a value bigger than 4 for fast
        % execution, no idea why
        handles.udp.CtrlTarget.BytesAvailableFcnCount = 8;
        handles.udp.CtrlTarget.BytesAvailableFcnMode = 'byte';
        handles.udp.CtrlTarget.BytesAvailableFcn = {'update_CtrlTarget_Callback', handles};
        handles.udp.CtrlTarget.InputBufferSize = 256;
        handles.udp.CtrlTarget.DatagramTerminateMode = 'off';

        fopen(handles.udp.CtrlTarget);
        state = 1;
        
    elseif on_off == 0        % delete udp object
        fclose(handles.udp.CtrlTarget);
        delete(handles.udp.CtrlTarget);
        state = 0;
    else
        error('Wrong input value on_off');
    end
    
catch
    delete(handles.udp.CtrlTarget);
    state = -1;
end

end

