function [ handles, state ] = udp_GetParam( input, on_off )
%UDP_GETPARAM Summary of this function goes here
%   Detailed explanation goes here
handles = input;
try
    if on_off == 1   % setup udp object
        IPAddress = get(handles.TargetIPAddress,'String');
        remotePort = 25002;
        localPort = handles.API.GetParam.RemotePort;

        % create udp object
        handles.udp.Get = udp(IPAddress, remotePort, 'LocalPort',localPort);
        handles.udp.Get.Name = 'udp_GetParam';
        handles.udp.Get.ByteOrder = 'littleEndian';
        handles.udp.Get.BytesAvailableFcnCount = 4*numel(handles.API.GetParam.ParamName);
        handles.udp.Get.BytesAvailableFcnMode = 'byte';
        handles.udp.Get.BytesAvailableFcn = {@update_GetParam_Callback, handles};
        handles.udp.Get.InputBufferSize = 2*512;
        handles.udp.Get.DatagramTerminateMode = 'off';
        % opten udp object
        fopen(handles.udp.Get);
        state = 1;
        
    elseif on_off == 0        % delete udp object
        fclose(handles.udp.Get);
        delete(handles.udp.Get);
        state = 0;
    else
        error('Wrong input value on_off');
    end
    
catch
    delete(handles.udp.Get);
    state = -1;
end
end

