function [ handles, state ] = udp_SetParam( input, on_off )
%UDP_SETPARAM Summary of this function goes here
%   Detailed explanation goes here
handles = input;


try
    if on_off == 1   % setup udp object
        IPAddress = get(handles.TargetIPAddress,'String');
        remotePort = handles.API.SetParam.localPort;
        localPort = handles.API.SetParam.remotePort;

        % create udp object
        handles.udp.Set = udp(IPAddress, remotePort, 'LocalPort',localPort);
        handles.udp.Set.Name = 'udp_SetParam';
        handles.udp.Set.ByteOrder = 'littleEndian';
        handles.udp.Set.BytesAvailableFcnCount = 4*numel(handles.API.SetParam.ParamName);
        handles.udp.Set.BytesAvailableFcnMode = 'byte';
        handles.udp.Set.BytesAvailableFcn = {@update_SetParam_Callback, handles};
        handles.udp.Set.InputBufferSize = 2*512;
        handles.udp.Set.DatagramTerminateMode = 'off';
        % open udp object
        fopen(handles.udp.Set);
        state = 1;
        
    elseif on_off == 0        % delete udp object
        fclose(handles.udp.Set);
        delete(handles.udp.Set);
        state = 0;
    else
        error('Wrong input value on_off');
    end
    
catch
    delete(handles.udp.Set);
    state = -1;
end
end

