function [ handles, state ] = udp_TriggerSetValues( input, on_off )
%UDP_TRIGGERSETVALUES Summary of this function goes here
%   Detailed explanation goes here
handles = input;

try
    if on_off   % setup udp object
        handles.PLFIFOBuf.ReadoutSizeSetParam = numel(handles.API.PLFIFOBuf.SetParamName);
        
        % configure UDP obj (FIFO Set, Readback Set)
        IPAddress = get(handles.TargetIPAddress,'String');
        remotePort = handles.API.PLFIFOBuf.LocalPort;
        localPort = handles.API.PLFIFOBuf.RemotePort;

        % create udp object
        handles.udp.PLFIFOBuf = udp(IPAddress, remotePort, 'LocalPort',localPort);
        handles.udp.PLFIFOBuf.Name = 'udp_TriggerSetValues';
        handles.udp.PLFIFOBuf.ByteOrder = 'littleEndian';
        handles.udp.PLFIFOBuf.BytesAvailableFcnCount = ...
            4*(handles.PLFIFOBuf.ReadoutSizeSetParam + 1);   % times 4 due to the datatype uint32 =  4bytes, + 1 due to trigger signal readback
        handles.udp.PLFIFOBuf.BytesAvailableFcnMode = 'byte';
        handles.udp.PLFIFOBuf.BytesAvailableFcn = {'update_TriggerSetValues_Callback', handles};
        handles.udp.PLFIFOBuf.InputBufferSize = 8*handles.udp.PLFIFOBuf.BytesAvailableFcnCount;
        handles.udp.PLFIFOBuf.DatagramTerminateMode = 'off';

        fopen(handles.udp.PLFIFOBuf);
        state = 1;
        
    elseif on_off == 0        % delete udp object
        fclose(handles.udp.PLFIFOBuf);
        % delete udp object
        delete(handles.udp.PLFIFOBuf);
        state = 0;
    else
        error('Wrong input value on_off');
    end
catch
    try
        delete(handles.udp.PLFIFOBuf);
    catch
    end
    state = -1;
end


end

