function update_ContSig_Callback(obj, ~, handles )
%UPDATE_CONTSIG_CALLBACK Summary of this function goes here
%   Detailed explanation goes here
ValuesPerChannel = obj.ValuesReceived/2;

x_offset = mod(ValuesPerChannel,handles.ringBufferSize);
x_vec = handles.API.ContSig.SigBufferSize;
time = (0:handles.API.ContSig.SampleTime:(handles.API.ContSig.SampleTime*(x_vec-1)))';
data = getappdata(handles.GUI_Storage,'SignalData');
rawdata = uint32(fread(obj,handles.ContSig.ReadoutSize,'uint32'));

% uncomment the following lines for plot Version 1:
% if (x_offset == (handles.ringBufferSize - x_vec) || ValuesPerChannel == 0)% last possible position
%     data_idx_plot = 1:handles.ringBufferSize;
% else
%     data_idx_plot = [x_offset+x_vec+1:handles.ringBufferSize,1:x_offset + x_vec-1];
% end

% new data index
data_idx_data = (x_offset+1):(x_offset+x_vec);
% x Axis range limit
xAxisRange = str2double(handles.xAxisTime.String);
% TODO: accelerate this for loop (mex file)
for idx = 1:2
    data(data_idx_data,idx*2) = reinterpretcast(rawdata(handles.ContSig.t(idx,:)),handles.ContSig.T(idx));
    data(data_idx_data,idx*2-1) = time + (handles.API.ContSig.SampleTime * ValuesPerChannel);
    % plot Version 1: Datatips are available, slower than animatedline
    %set(handles.h(idx),'XData',data(data_idx_plot,idx*2-1),'YData',data(data_idx_plot,idx*2));
    % plot Vserion 2: Datatips not available, very fast
    addpoints(handles.h(idx),data(data_idx_data,idx*2-1),data(data_idx_data,idx*2));
    % rolling axes
    handles.(['ContinuousSignal',num2str(idx)]).XLim = [max([(max(data(:,idx*2-1))-xAxisRange);0]), max([data(:,idx*2-1);xAxisRange])];
end
drawnow;

% save to file before buffer overwriting (.mat and bit file)
% .mat file is more comfortable to readback and smaller storage size, but takes 5 times
% more time
% to read back mat file in folder: listing = dir(fullfile('StoredData','*.mat'))
if x_offset == (handles.ringBufferSize - x_vec) % last entry made in ringBuffer 
    t = datestr(now,'yy_mm_dd_HHMMss'); % generate time stamp
%     fid = fopen(fullfile(handles.StorePath,sprintf('%s_ContinuousSignal.bin',t)),'w');
%     fwrite(fid,data,'single');
%     fclose(fid);
    save(fullfile(handles.StorePath,sprintf('%s_ContinuousSignal.mat',t)),'data');
end
setappdata(handles.GUI_Storage,'SignalData',data);
end

