function update_SetParam_Callback(obj, ~, handles)
%UPDATE_SETPARAM_CALLBACK Summary of this function goes here
%   Detailed explanation goes here
nrElem = numel(handles.API.SetParam.ParamName);
% read rawdata
rawdata = fread(obj, nrElem, 'uint32');
% load current SetData from table
data = get(handles.SetParametersTable,'Data');
T_uint32 = numerictype(0,32,0);
transformedData = zeros(nrElem,1);
for idx = 1:nrElem
    GetValue = rawdata(idx);
    Get_uint32Value = fi(GetValue,T_uint32);
    % read out original datatype
    datatype = data{idx,6};
    if strfind(datatype, 'boolean')
        transformedData(idx,1) = str2double(Get_uint32Value.Value);
    else
        datatype = numerictype(datatype);
        % change wordlength to 32
        datatype.WordLength = 32;
        % transform uint32 back to original datatype
        backTransformedValue = reinterpretcast(Get_uint32Value,datatype);
        transformedData(idx,1) = str2double(backTransformedValue.Value);
    end
end
% rearange data to write in table
data(:,2) = mat2cell(transformedData,ones(numel(rawdata),1));
% write new GetData in table
set(handles.SetParametersTable,'Data',data);
end

