%% Persistent deployment of generated code and bit file
% check if zynq object exist in workspace
if ~exist('z','var')
    z = zynq();
else
    if ~isa(z,'zynq.util.LinuxServices')
    z = zynq();
    end
end
% variables
elfsearchpath = '..\work\';
bitsearchpath = '..\work\hdl_prj\vivado_ip_prj\vivado_prj.runs\impl_1\';
[elffile, elfpath, ~] = uigetfile([elfsearchpath,'*.*'],'Select the software to be deployed...');
[bitfile, bitpath, ~] = uigetfile([bitsearchpath,'*.bit'],'Select the bitfile to be deployed...');
exname = 'system.elf';
bitname = 'system.bit';

% deploy chosen code file to mnt
if ~ischar(elffile) || ~ischar(bitfile)
    error('Executable or bit file not chosen.')
else
    if strcmp(z.checkConnection,['Connection successful' 10]);
        % check if destination folder exist
        [status, msg] = z.execute('if test -d /mnt/Model; then echo "exist"; fi', true);
        if ~strcmp(msg,'exist')
            z.execute('mkdir /mnt/Model/');
        end
        % deploy chosen code file to /mnt/Model/
        z.execute(['rm /mnt/Model/', exname]);
        z.putFile([elfpath, elffile],['/mnt/Model/', exname]);
        % deploy chosen bit file to mnt
        z.execute(['rm /mnt/Model/', bitname]);
        z.putFile([bitpath, bitfile],['/mnt/Model/', bitname]);
        % reboot system to program fpga and run program
        z.execute('reboot');
    else
        error('Could not establish connection.')
    end
end