#!/bin/sh

# Here you can put the scrips and commands which should be run at startup.

# Program the persistently deployed bitfile if available
if [ -f /mnt/Model/system.bit ]; then
    echo "Programming persistently deployed bitfile...."
    /usr/bin/zynqfpgaprog /mnt/Model/system.bit
fi

# Load the Mathworks AXI kernel module
modprobe mwadma
modprobe mwgeneric_of

# wait for the ethernet to be fully set up before starting the model (UDP blocks)
sleep 30

# Program the persistently deployed ps software if available
if [ -f /mnt/Model/system.elf ]; then
    echo "Starting persistently deployed software...."
    ./mnt/Model/system.elf &
fi

echo "/mnt/startup.sh called sucessfully! "


