% This script uploads new system software to the ZedBoard.
%
% Execute this in a terminal as a normal user from the parent directory of the 
% new SD card contents. Reboot the ZedBoard manually afterwards.
%
% WARNING: All contents in the root folder of the SD card are deleted! Folders
%          and files they contain are unharmed.
%

%% initalize ZedBoard connection
z = zynq('linux', '192.168.2.101', 'root', 'root', '/tmp');
msg = z.checkConnection; 
fprintf([msg]);

%% clearing root of SD card
z.execute('rm /mnt/*');

%% upload new software files
z.putFile(strcat(pwd,'\sdcard\*'),'/mnt/');


%% reboot ZedBoard to load the new system software
z.execute('reboot');