#!/bin/sh
#
# This script uploads new system software to the ZedBoard.
#
# Execute this in a terminal as a normal user from the parent directory of the 
# new SD card contents. Reboot the ZedBoard manually afterwards.
#
# WARNING: All contents in the root folder of the SD card are deleted! Folders
#          and files they contain are unharmed.
#

SD_CONTENTS_DIR=sdcard
ZEDBOARD_USER=root
ZEDBOARD_USER_PWD=root

if [ -d $SD_CONTENTS_DIR ]; then  
    sshpass -p $ZEDBOARD_USER_PWD ssh $ZEDBOARD_USER@192.168.2.101 'rm /mnt/* &>/dev/null' 
    sshpass -p $ZEDBOARD_USER_PWD scp $SD_CONTENTS_DIR/* $ZEDBOARD_USER@192.168.2.101:/mnt/.
    echo "OK"
else
    echo "Folder with new SD card contents not found!"
fi 
