# Packaging IP
#
# Set paths for IP core and logo image (you may change the paths)
set ip_path C:/path/custom_IP_core
set ip_logo_path C:/path/custom_IP_Logo.png

# Package the current project
#
#  [-root_dir]         User specified root directory for component.xml -       
#  [-import_files]     Import remote IP files into the IP structure.  
#  [-force]            Override existing packaged component.xml.
ipx::package_project -root_dir $ip_path -import_files -force 

# Suppress the following warning message 
# (it is safe to ignore this warning if you do not have any bus interfaces on your custom IP)
set_msg_config -suppress -id {IP_Flow 19-3153} -string {{WARNING: [IP_Flow 19-3153] Bus Interface 'signal_clock': ASSOCIATED_BUSIF bus parameter is missing.} }

# Set category to UserIP
set_property taxonomy /UserIP [ipx::current_core]

# Since reset is active high -> correct to the right polarity
set_property value ACTIVE_HIGH [ipx::get_bus_parameters POLARITY -of_objects [ipx::get_bus_interfaces signal_reset -of_objects [ipx::current_core]]]

# Remove unused ports
ipx::remove_port ce_out [ipx::current_core]

# Set core revision
set_property core_revision 2 [ipx::current_core]

# Create default XGUI files for block diagram with logo
ipx::create_xgui_files -logo_file $ip_logo_path -logo_width 24 -logo_height 24 [ipx::current_core]

# Update and save IP core
ipx::update_checksums [ipx::current_core]
ipx::save_core [ipx::current_core]

# Add IP core to the project repository (copy these commands for other projects)
set_property ip_repo_paths  $ip_path [current_project]
update_ip_catalog