-- -------------------------------------------------------------
-- 
-- File Name: hdl_prj_ipcore2\hdlsrc\XADC_Single\ExtVoltConvert.vhd
-- Created: 2016-06-02 23:32:07
-- 
-- Generated by MATLAB 8.6 and HDL Coder 3.7
-- 
-- -------------------------------------------------------------


-- -------------------------------------------------------------
-- 
-- Module: ExtVoltConvert
-- Source Path: XADC_Single/xadc_reader_single/XADC_Com_Interface/ExtVoltConvert
-- Hierarchy Level: 2
-- 
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;
USE work.xadc_reader_single_pkg.ALL;

ENTITY ExtVoltConvert IS
  PORT( clk                               :   IN    std_logic;
        reset                             :   IN    std_logic;
        enb                               :   IN    std_logic;
        Raw                               :   IN    std_logic_vector(11 DOWNTO 0);  -- ufix12
        Volts                             :   OUT   std_logic_vector(15 DOWNTO 0)  -- ufix16_En15
        );
END ExtVoltConvert;


ARCHITECTURE rtl OF ExtVoltConvert IS

  -- Signals
  SIGNAL Raw_unsigned                     : unsigned(11 DOWNTO 0);  -- ufix12
  SIGNAL Raw_1                            : unsigned(11 DOWNTO 0);  -- ufix12
  SIGNAL Gain_cast                        : unsigned(23 DOWNTO 0);  -- ufix24_En23
  SIGNAL Gain_out1                        : unsigned(15 DOWNTO 0);  -- ufix16_En15
  SIGNAL Gain_out_pipe_reg                : vector_of_unsigned16(0 TO 1);  -- ufix16 [2]
  SIGNAL Gain_out1_1                      : unsigned(15 DOWNTO 0);  -- ufix16_En15

BEGIN
  Raw_unsigned <= unsigned(Raw);

  Gain_in_pipe_process : PROCESS (clk)
  BEGIN
    IF clk'EVENT AND clk = '1' THEN
      IF reset = '1' THEN
        Raw_1 <= to_unsigned(16#000#, 12);
      ELSIF enb = '1' THEN
        Raw_1 <= Raw_unsigned;
      END IF;
    END IF;
  END PROCESS Gain_in_pipe_process;


  Gain_cast <= resize(Raw_1 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 24);
  Gain_out1 <= Gain_cast(23 DOWNTO 8);

  Gain_out_pipe_process : PROCESS (clk)
  BEGIN
    IF clk'EVENT AND clk = '1' THEN
      IF reset = '1' THEN
        Gain_out_pipe_reg <= (OTHERS => to_unsigned(16#0000#, 16));
      ELSIF enb = '1' THEN
        Gain_out_pipe_reg(0) <= Gain_out1;
        Gain_out_pipe_reg(1) <= Gain_out_pipe_reg(0);
      END IF;
    END IF;
  END PROCESS Gain_out_pipe_process;

  Gain_out1_1 <= Gain_out_pipe_reg(1);

  Volts <= std_logic_vector(Gain_out1_1);

END rtl;

