-- -------------------------------------------------------------
-- 
-- File Name: hdl_prj_ipcore2\hdlsrc\XADC_Single\TempConvert.vhd
-- Created: 2016-06-02 23:32:07
-- 
-- Generated by MATLAB 8.6 and HDL Coder 3.7
-- 
-- -------------------------------------------------------------


-- -------------------------------------------------------------
-- 
-- Module: TempConvert
-- Source Path: XADC_Single/xadc_reader_single/XADC_Com_Interface/TempConvert
-- Hierarchy Level: 2
-- 
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;
USE work.xadc_reader_single_pkg.ALL;

ENTITY TempConvert IS
  PORT( clk                               :   IN    std_logic;
        reset                             :   IN    std_logic;
        enb                               :   IN    std_logic;
        Raw                               :   IN    std_logic_vector(11 DOWNTO 0);  -- ufix12
        DegC                              :   OUT   std_logic_vector(15 DOWNTO 0)  -- sfix16_En6
        );
END TempConvert;


ARCHITECTURE rtl OF TempConvert IS

  -- Signals
  SIGNAL Raw_unsigned                     : unsigned(11 DOWNTO 0);  -- ufix12
  SIGNAL Raw_1                            : unsigned(11 DOWNTO 0);  -- ufix12
  SIGNAL Gain_mul_temp                    : unsigned(23 DOWNTO 0);  -- ufix24_En15
  SIGNAL Gain_out1                        : unsigned(14 DOWNTO 0);  -- ufix15_En6
  SIGNAL Gain_out_pipe_reg                : vector_of_unsigned15(0 TO 1);  -- ufix15 [2]
  SIGNAL Gain_out1_1                      : unsigned(14 DOWNTO 0);  -- ufix15_En6
  SIGNAL Constant_out1                    : unsigned(14 DOWNTO 0);  -- ufix15_En6
  SIGNAL Add_sub_cast                     : signed(15 DOWNTO 0);  -- sfix16_En6
  SIGNAL Add_sub_cast_1                   : signed(15 DOWNTO 0);  -- sfix16_En6
  SIGNAL Add_out1                         : signed(15 DOWNTO 0);  -- sfix16_En6
  SIGNAL Add_out1_1                       : signed(15 DOWNTO 0);  -- sfix16_En6

BEGIN
  Raw_unsigned <= unsigned(Raw);

  Gain_in_pipe_process : PROCESS (clk)
  BEGIN
    IF clk'EVENT AND clk = '1' THEN
      IF reset = '1' THEN
        Raw_1 <= to_unsigned(16#000#, 12);
      ELSIF enb = '1' THEN
        Raw_1 <= Raw_unsigned;
      END IF;
    END IF;
  END PROCESS Gain_in_pipe_process;


  -- CSD Encoding (4032) : 1000001'000000; Cost (Adders) = 1
  Gain_mul_temp <= (Raw_1 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0') - resize(Raw_1 & '0' & '0' & '0' & '0' & '0' & '0', 24);
  Gain_out1 <= Gain_mul_temp(23 DOWNTO 9);

  Gain_out_pipe_process : PROCESS (clk)
  BEGIN
    IF clk'EVENT AND clk = '1' THEN
      IF reset = '1' THEN
        Gain_out_pipe_reg <= (OTHERS => to_unsigned(16#0000#, 15));
      ELSIF enb = '1' THEN
        Gain_out_pipe_reg(0) <= Gain_out1;
        Gain_out_pipe_reg(1) <= Gain_out_pipe_reg(0);
      END IF;
    END IF;
  END PROCESS Gain_out_pipe_process;

  Gain_out1_1 <= Gain_out_pipe_reg(1);

  Constant_out1 <= to_unsigned(16#444A#, 15);

  Add_sub_cast <= signed(resize(Gain_out1_1, 16));
  Add_sub_cast_1 <= signed(resize(Constant_out1, 16));
  Add_out1 <= Add_sub_cast - Add_sub_cast_1;

  Add_out_pipe_process : PROCESS (clk)
  BEGIN
    IF clk'EVENT AND clk = '1' THEN
      IF reset = '1' THEN
        Add_out1_1 <= to_signed(16#0000#, 16);
      ELSIF enb = '1' THEN
        Add_out1_1 <= Add_out1;
      END IF;
    END IF;
  END PROCESS Add_out_pipe_process;


  DegC <= std_logic_vector(Add_out1_1);

END rtl;

