-- -------------------------------------------------------------
-- 
-- File Name: hdl_prj_ipcore2\hdlsrc\XADC_Single\XADC_Com_Interface.vhd
-- Created: 2016-06-02 23:32:07
-- 
-- Generated by MATLAB 8.6 and HDL Coder 3.7
-- 
-- -------------------------------------------------------------


-- -------------------------------------------------------------
-- 
-- Module: XADC_Com_Interface
-- Source Path: XADC_Single/xadc_reader_single/XADC_Com_Interface
-- Hierarchy Level: 1
-- 
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;
USE work.xadc_reader_single_pkg.ALL;

ENTITY XADC_Com_Interface IS
  PORT( clk                               :   IN    std_logic;
        reset                             :   IN    std_logic;
        enb                               :   IN    std_logic;
        drdy_i                            :   IN    std_logic;
        do_i                              :   IN    std_logic_vector(15 DOWNTO 0);  -- uint16
        den_o                             :   OUT   std_logic;
        daddr_o                           :   OUT   std_logic_vector(6 DOWNTO 0);  -- ufix7
        temp                              :   OUT   std_logic_vector(15 DOWNTO 0);  -- sfix16_En6
        vpvn                              :   OUT   std_logic_vector(15 DOWNTO 0)  -- ufix16_En15
        );
END XADC_Com_Interface;


ARCHITECTURE rtl OF XADC_Com_Interface IS

  -- Component Declarations
  COMPONENT xadc_ctrl
    PORT( clk                             :   IN    std_logic;
          reset                           :   IN    std_logic;
          enb                             :   IN    std_logic;
          drdy_i                          :   IN    std_logic;
          do_i                            :   IN    std_logic_vector(15 DOWNTO 0);  -- uint16
          den_o                           :   OUT   std_logic;
          daddr_o                         :   OUT   std_logic_vector(6 DOWNTO 0);  -- ufix7
          val_o                           :   OUT   vector_of_std_logic_vector16(0 TO 1)  -- uint16 [2]
          );
  END COMPONENT;

  COMPONENT TempConvert
    PORT( clk                             :   IN    std_logic;
          reset                           :   IN    std_logic;
          enb                             :   IN    std_logic;
          Raw                             :   IN    std_logic_vector(11 DOWNTO 0);  -- ufix12
          DegC                            :   OUT   std_logic_vector(15 DOWNTO 0)  -- sfix16_En6
          );
  END COMPONENT;

  COMPONENT ExtVoltConvert
    PORT( clk                             :   IN    std_logic;
          reset                           :   IN    std_logic;
          enb                             :   IN    std_logic;
          Raw                             :   IN    std_logic_vector(11 DOWNTO 0);  -- ufix12
          Volts                           :   OUT   std_logic_vector(15 DOWNTO 0)  -- ufix16_En15
          );
  END COMPONENT;

  -- Component Configuration Statements
  FOR ALL : xadc_ctrl
    USE ENTITY work.xadc_ctrl(rtl);

  FOR ALL : TempConvert
    USE ENTITY work.TempConvert(rtl);

  FOR ALL : ExtVoltConvert
    USE ENTITY work.ExtVoltConvert(rtl);

  -- Signals
  SIGNAL daddr_o_tmp                      : std_logic_vector(6 DOWNTO 0);  -- ufix7
  SIGNAL val_o                            : vector_of_std_logic_vector16(0 TO 1);  -- ufix16 [2]
  SIGNAL val_o_unsigned                   : vector_of_unsigned16(0 TO 1);  -- uint16 [2]
  SIGNAL GetMSB_out1                      : vector_of_unsigned12(0 TO 1);  -- ufix12 [2]
  SIGNAL TempConvert_out1                 : std_logic_vector(15 DOWNTO 0);  -- ufix16
  SIGNAL ExtVoltConvert_out1              : std_logic_vector(15 DOWNTO 0);  -- ufix16

BEGIN
  u_xadc_ctrl : xadc_ctrl
    PORT MAP( clk => clk,
              reset => reset,
              enb => enb,
              drdy_i => drdy_i,
              do_i => do_i,  -- uint16
              den_o => den_o,
              daddr_o => daddr_o_tmp,  -- ufix7
              val_o => val_o  -- uint16 [2]
              );

  u_TempConvert : TempConvert
    PORT MAP( clk => clk,
              reset => reset,
              enb => enb,
              Raw => std_logic_vector(GetMSB_out1(0)),  -- ufix12
              DegC => TempConvert_out1  -- sfix16_En6
              );

  u_ExtVoltConvert : ExtVoltConvert
    PORT MAP( clk => clk,
              reset => reset,
              enb => enb,
              Raw => std_logic_vector(GetMSB_out1(1)),  -- ufix12
              Volts => ExtVoltConvert_out1  -- ufix16_En15
              );

  outputgen: FOR k1 IN 0 TO 1 GENERATE
    val_o_unsigned(k1) <= unsigned(val_o(k1));
  END GENERATE;


  GetMSB_out1_gen: FOR k IN 0 TO 1 GENERATE
    GetMSB_out1(k) <= val_o_unsigned(k)(15 DOWNTO 4);
  END GENERATE GetMSB_out1_gen;


  daddr_o <= daddr_o_tmp;

  temp <= TempConvert_out1;

  vpvn <= ExtVoltConvert_out1;

END rtl;

